declare type AbortableChainStageExecutor<I, O> = (lastStageOutput: I, signal: AbortSignal) => O | Promise<O>;
declare type AbortableChainStage<I> = {
    add<O>(fn: AbortableChainStageExecutor<I, O>): AbortableChainStage<Awaited<O>>;
    exec(): Promise<I>;
};
export default class AbortableChain implements AbortableChainStage<void> {
    private readonly abortSignal;
    private readonly stages;
    constructor(abortSignal: AbortSignal);
    add<O>(fn: (lastStageOutput: any, signal: AbortSignal) => O | Promise<O>): AbortableChainStage<Awaited<O>>;
    exec(): Promise<any>;
}
export {};
